mkdir DOUAR
cp clean DOUAR
cp cleandata DOUAR
cp README DOUAR
cp *.f90 DOUAR
cp *.c DOUAR
cp Makefile* DOUAR
cp input.* DOUAR
cp Input_Description.txt Pecube
cp release_notes DOUAR
cp runjob.sh DOUAR
cp checkjob.sh DOUAR

mkdir DOUAR/NN
cp NN/*.f 		DOUAR/NN
cp NN/*.c 		DOUAR/NN
cp NN/*.cc 		DOUAR/NN
cp NN/Makefile* 	DOUAR/NN
cp NN/clean	 	DOUAR/NN

mkdir DOUAR/OCTREE
cp OCTREE/OctreeBitPlus.f90 	DOUAR/OCTREE
cp OCTREE/*.f 			DOUAR/OCTREE
cp OCTREE/Makefile* 		DOUAR/OCTREE
cp OCTREE/clean 		DOUAR/OCTREE

mkdir DOUAR/CASCADE
cp CASCADE/*.f DOUAR/CASCADE
cp CASCADE/*.c DOUAR/CASCADE
cp CASCADE/*.cc DOUAR/CASCADE
cp CASCADE/Makefile* DOUAR/CASCADE

mkdir DOUAR/PLOT
cp PLOT/triplot.f90 	DOUAR/PLOT
cp PLOT/triplot.txt 	DOUAR/PLOT
cp PLOT/Makefile* 	DOUAR/PLOT

mkdir DOUAR/VTK
cp VTK/*.f90 			DOUAR/VTK
cp VTK/Makefile* 		DOUAR/VTK
cp VTK/input_of_outputs.txt 	DOUAR/VTK
cp VTK/clean 			DOUAR/VTK
cp VTK/*.sh			DOUAR/VTK
cp VTK/*.py			DOUAR/VTK
cp VTK/*.txt			DOUAR/VTK
cp VTK/*.mv			DOUAR/VTK
cp VTK/*.in                     DOUAR/VTK

mkdir DOUAR/OUT
cp OUT/clean 		DOUAR/OUT

mkdir DOUAR/XSC
cp XSC/clean 		DOUAR/XSC
cp XSC/convertscript 	DOUAR/XSC

mkdir DOUAR/SG
mkdir DOUAR/SG/L_continent
cp SG/L_continent/*.f90 	DOUAR/SG/L_continent
cp SG/L_continent/clean 	DOUAR/SG/L_continent

mkdir DOUAR/SG/parpaing
cp SG/parpaing/*.f90 		DOUAR/SG/parpaing
cp SG/parpaing/clean 		DOUAR/SG/parpaing
cp SG/parpaing/Makefile		DOUAR/SG/parpaing
cp SG/parpaing/input.surf	DOUAR/SG/parpaing

mkdir DOUAR/SG/sphere
cp SG/sphere/*.f90 		DOUAR/SG/sphere
cp SG/sphere/clean 		DOUAR/SG/sphere
cp SG/sphere/input.surf 	DOUAR/SG/sphere
cp SG/sphere/Makefile   	DOUAR/SG/sphere

cp SG/*.f90 		DOUAR/SG
cp SG/Makefile 		DOUAR/SG
cp SG/input.surf 	DOUAR/SG

mkdir DOUAR/DORURE
cp DORURE/clean 		DOUAR/DORURE
cp DORURE/Makefile      	DOUAR/DORURE
cp DORURE/postprocessing.f90 	DOUAR/DORURE

mkdir DOUAR/RESAMPLE
cp RESAMPLE/*.f       DOUAR/RESAMPLE
cp RESAMPLE/*.f90     DOUAR/RESAMPLE
cp RESAMPLE/Makefile  DOUAR/RESAMPLE
cp RESAMPLE/clean     DOUAR/RESAMPLE/clean

mkdir DOUAR/DEBUG

mkdir DOUAR/DEBUG/BC
cp DEBUG/BC/clean 		DOUAR/DEBUG/BC

mkdir DOUAR/DEBUG/FORCES
cp DEBUG/FORCES/clean 		DOUAR/DEBUG/FORCES
cp DEBUG/FORCES/Makefile 	DOUAR/DEBUG/FORCES
cp DEBUG/FORCES/post.f90	DOUAR/DEBUG/FORCES

mkdir DOUAR/DEBUG/SURFACES
cp DEBUG/SURFACES/clean 	DOUAR/DEBUG/SURFACES

mkdir DOUAR/DEBUG/OLSF
cp DEBUG/OLSF/post.f90 		DOUAR/DEBUG/OLSF
cp DEBUG/OLSF/Makefile 		DOUAR/DEBUG/OLSF
cp DEBUG/OLSF/clean 		DOUAR/DEBUG/OLSF

mkdir DOUAR/DEBUG/mpilogs
cp DEBUG/mpilogs/clean 		DOUAR/DEBUG/mpilogs

mkdir DOUAR/DEBUG/MATRIX
cp DEBUG/MATRIX/clean 		DOUAR/DEBUG/MATRIX

cp tarngo.sh DOUAR
tar -cvf DOUAR.tar DOUAR
gzip DOUAR.tar

rm -r DOUAR/
